// MainFrm.h : interface of the CMainFrame class
//
/////////////////////////////////////////////////////////////////////////////

class CTransformDlg;

class CMainFrame : public CFrameWnd
{
public:
	CMainFrame();
	DECLARE_DYNCREATE(CMainFrame)

// Attributes
public:
	C3dWnd		m_wnd3d;
	C3dScene* m_pScene;
	C3dController* m_pController;

// Operations
public:
	BOOL NewScene();
	BOOL OpenFile(const char* pszFile);
	void Status(const char* pszFormat, ...);

 

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMainFrame)
	public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void RecalcLayout(BOOL bNotify = TRUE);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CMainFrame();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:  // control bar embedded members
	CStatusBar  m_wndStatusBar;
	CToolBar    m_wndToolBar;
	int m_iControlObj;
	int m_iControlType;
	int m_iObjCtrlDev;
	CRect m_rcWnd;
	C3dShape* m_pCurShape;

	static C3dFrame* CALLBACK OnGetCtrlFrame(void* pArg);
	void SaveSettings();
	void RestoreSettings();
	static void CALLBACK OnSelChange(C3dShape* pShape, CPoint pt, void* pArg);
	void AddBlob(C3dShape* pShape, C3dVector& v);

// Generated message map functions
protected:
	//{{AFX_MSG(CMainFrame)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy();
	afx_msg void OnActivateApp(BOOL bActive, HTASK hTask);
	afx_msg void OnPaletteChanged(CWnd* pFocusWnd);
	afx_msg void OnMove(int x, int y);
	afx_msg void OnFileNew();
	afx_msg void OnSetFocus(CWnd* pOldWnd);
	afx_msg void OnEditControl();
	afx_msg void OnUpdateEditControl(CCmdUI* pCmdUI);
	afx_msg void OnEditInputdev();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
