// Stage.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "Stage.h"

#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CStageApp

BEGIN_MESSAGE_MAP(CStageApp, CWinApp)
	//{{AFX_MSG_MAP(CStageApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CStageApp construction

CStageApp::CStageApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CStageApp object

CStageApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CStageApp initialization

BOOL CStageApp::InitInstance()
{
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	// define the name of the registry key where we want to save
	// all our profile information. This value is appended to:
	// HKEY_CURRENT_USER\Software
	// The application name is appended after this key value to
	// form the complete key. For example:
	// HKEY_CURRENT_USER\Software\MyApp
	SetRegistryKey("3dPlus");

	LoadStdProfileSettings();  // Load standard INI file options (including MRU)

	// Load the main frame window
	CMainFrame* pFrame = new CMainFrame;
	if (!pFrame->LoadFrame(IDR_MAINFRAME, WS_OVERLAPPEDWINDOW | WS_VISIBLE)) {
		return FALSE;
	}
		              
	// save the main window pointer
	m_pMainWnd = pFrame;

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CStageApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CStageApp commands

BOOL CStageApp::OnIdle(LONG lCount) 
{
	BOOL bMore = CWinApp::OnIdle(lCount);
	
	// get the main frame window
	CMainFrame* pFrame = (CMainFrame*) m_pMainWnd;
	if (pFrame) {

		// see if the object controller wants to do anything
		if (pFrame->m_pController) {
			pFrame->m_pController->Update();
		}

		// tell the 3D window to update
		if (pFrame->m_wnd3d.Update(1)) {
			bMore = TRUE;
		} 
	}
	return bMore;
}

CDocument* CStageApp::OpenDocumentFile(LPCTSTR lpszFileName) 
{
	// we get called here when the user selects an item
	// from the recent file list.
	// The return value is not importenat so long
	// as it's NULL if we fail and non-NULL if we succeed
	
	CMainFrame* pFrame = (CMainFrame*) m_pMainWnd;
	if (pFrame) {
		return (CDocument*) pFrame->OpenFile(lpszFileName);
	} else {
		return NULL;
	}
}
